诀窍是使用 Microstation API 获取要操作的元素列表。您可以使用.GetSelectedElements
或.Scan
取决于您希望工具如何工作。正如您所说,您刚刚习惯了 vba,我对下面的代码进行了大量评论。
.Rewrite
其他陷阱包括文本元素和文本节点(多行文本)需要以不同方式处理,并且一旦您修改了元素,请不要忘记它。
Option Explicit
Sub replaceText()
Dim findText() As String
Dim replaceText() As String
'set find and replace
findText = Split("10 20 30 40 50")
replaceText = Split("a b c d e")
'guard against unequal length searches
If UBound(findText) <> UBound(replaceText) Then
MsgBox "Find and replace are not equal lengths"
Exit Sub
End If
' Scan Criteria are needed when looking for elements in a model
' Set up scan criteria to only include text types
Dim eSC As New ElementScanCriteria
eSC.ExcludeAllTypes
eSC.IncludeType msdElementTypeText 'text element
eSC.IncludeType msdElementTypeTextNode 'multiple line text element
Dim model As ModelReference
Set model = ActiveModelReference
' if you need to loop through multiple models you could use this
' Set model = ActiveDesignFile.Models(i)
' Element Enumerator is a list of elements
Dim elements As ElementEnumerator
'scan active model for text
Set elements = model.Scan(eSC)
' the elements could also be retrieved using
' Set elements = model.GetSelectedElements
' iterate through element set
' If there is another element in the list then
' MoveNext sets elements.Current to the next element and returns true
' otherwise it returns false and the loop exits.
Do While elements.MoveNext
Dim i As Integer
Dim textNodeI As Integer
Dim tempText As String
' elements.Current is a generic element
' we need to check its type to handle it correctly
If elements.Current.IsTextElement Then
' access the generic element using the text element interface
With elements.Current.AsTextElement
'.text here refers to elements.Current.AsTextElement.text as specified by the With statement
tempText = .text
'split is 0 indexed
For i = 0 To UBound(findText)
tempText = Replace(tempText, findText(i), replaceText(i))
Next
'set the elements text to the replaced text
.text = tempText
'rewrite the text element to the model
.Rewrite
End With
ElseIf elements.Current.IsTextNodeElement Then
With elements.Current.AsTextNodeElement
' TextNodes have an array of TextLines (1 indexed)
For textNodeI = 1 To .TextLinesCount
'same as for text but for each line of node
tempText = .TextLine(textNodeI)
For i = 0 To UBound(findText)
tempText = Replace(tempText, findText(i), replaceText(i))
Next
.TextLine(textNodeI) = tempText
Next
' Rewrite the text node after you have replaced each line.
.Rewrite
End With
End If
Loop
End Sub